package pmm.antiaircraft3;

import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;

public class Bullet {
	private static final int STATUS_FLYING = 0;
	private static final int STATUS_BOOM = 1;
	private static final int STATUS_OVER = 2;
	private static final int BULLET_RADIUS  = 4;

	private static final long TIME_EXPLODING  = 100;

	private long time;

	private int status;
	private int power;
	private float posX0;
	private float posY0;
	private float posX;
	private float posY;
	private float iniSpeedX;
	private float iniSpeedY;

	private Paint paint;

	private long explodingTimer;

	public Bullet(int power,float angle,int x0,int y0){
		time=0;
		paint = new Paint();
		this.power = power;
		posX0 = x0;
		posY0 = y0;
		iniSpeedY=(float) (Math.sin(angle)*power*1.5) ;
		iniSpeedX=(float) (Math.cos(angle)*power*1.5);
	}

	public void draw(Canvas c) {
		paint.setColor(Color.RED);
		if (status == STATUS_FLYING)
			paint.setColor(Color.BLACK);
		c.drawCircle(posX, posY, BULLET_RADIUS, paint);
	}

	public void update(long elapsedTime) {
		switch (status){		
		case STATUS_FLYING:
			time+=elapsedTime;
			double t2=(double)(time)/100;
			posX=(float) (posX0 + iniSpeedX*t2);
			posY=(float) (posY0 - (iniSpeedY*t2 - (9.8 *Math.pow(t2, 2)/2)));

			if (posY>=480) {
				status=STATUS_BOOM;
				posY = 480;
				explodingTimer = 0;
			}
			break;
		case STATUS_BOOM:
			explodingTimer+=elapsedTime;
			if (explodingTimer>TIME_EXPLODING)
				status=STATUS_OVER;
			break;
		}
	}

	public void setImpact(){
		status = STATUS_BOOM;
		explodingTimer=0;
	}

	public float getPosX() {
		return posX;
	}

	public float getPosY() {
		return posY;
	}

	public boolean isFlying(){
		return (status == STATUS_FLYING);
	}

	public boolean isExploding() {
		return (status==STATUS_BOOM);
	}

	public boolean isOver() {
		return (status==STATUS_OVER);
	}

}