package pmm.antiaircraft5;

import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Matrix;

public class Tank {
	private static final int TANK_HEIGHT = 50;
	private static final int TANK_WIDTH = 50;
	private static final int TANK_TOP = 480 - TANK_HEIGHT;
	private static final int CANNON_WIDTH = 10;
	private static final int GUNBARREL_LENGTH = 46;
	private static final int STATUS_IDLE=0;
	private static final int STATUS_POWERING=1;
	private static final long POWERING_TIMER_LIMIT = 1200;
	private float angle;
	public static int cannonEndX;
	public static int cannonEndY;
	private int status;
	private long poweringTimer;
	private int power;
	private int lastBulletPower;

	public Tank(){
		GameThread.tankImg=Bitmap.createBitmap(GameThread.tankImg);
		GameThread.cannonImg=Bitmap.createBitmap(GameThread.cannonImg);
	}

	public void draw(Canvas c) {
		c.drawBitmap(GameThread.tankImg, (320-TANK_WIDTH)/2, TANK_TOP, null);	
		Matrix m = new Matrix();
		m.postTranslate((320-CANNON_WIDTH)/2, TANK_TOP - 30);
		m.postRotate((float) ((-angle)*180 /Math.PI),160,446);
		c.drawBitmap(GameThread.cannonImg, m, null);
		cannonEndX = (int) (160 + (Math.cos(angle) * GUNBARREL_LENGTH));
		cannonEndY = (int) (446 - (Math.sin(angle) * GUNBARREL_LENGTH));
	}
	
	public void setTarget(int x, int y) {
		if (x==160)
			angle=0;
		else{
			if(y>=446){
				angle=(float)Math.PI/2;
				if(x>160)
					angle-=2*angle;
			}
			else
				angle = (float) Math.atan((float)(x-160)/(float)(y-446));
		}
	}
	
	public void update(long elapsedTime){		
		if (status == STATUS_POWERING){
			poweringTimer=poweringTimer+elapsedTime;
			if (poweringTimer>POWERING_TIMER_LIMIT)
				poweringTimer=POWERING_TIMER_LIMIT;
			power = (int) (((float)poweringTimer / POWERING_TIMER_LIMIT) *100);
		}
	}
	
	public void pressFire( ) {
		status = STATUS_POWERING;
		power = 0;		
		poweringTimer = 0;
	}
	
	public void releaseFire() {
		GameThread.shootBullet(angle+(float)Math.PI/2,40+power*60/100,160,446);	
		lastBulletPower = power;
		status = STATUS_IDLE;
		power = 0;
	}
	
	public int getPower() {
		return power;
	}

	public float getAngle() {
		return angle;
	}

	public int getLastBulletPower() {
		return lastBulletPower;
	}
}