package pmm.antiaircraft6;

import java.util.concurrent.ArrayBlockingQueue;

import android.app.Activity;
import android.view.MotionEvent;
import android.view.Window;
import android.view.WindowManager;

public class GameActivity extends Activity{

	private GameThread mGameThread;
	public static final int INPUT_QUEUE_SIZE = 30;
	public ArrayBlockingQueue<InputObject> inputObjectPool;
	
	public void onStart() {
		super.onStart();
		requestWindowFeature(Window.FEATURE_NO_TITLE);
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
		setContentView(R.layout.main);
		mGameThread = ((GameView) findViewById(R.id.game)).getThread();
		mGameThread.createGraphics();
		createInputObjectPool();
	}
	
	private void createInputObjectPool() {
		inputObjectPool = new ArrayBlockingQueue<InputObject>(INPUT_QUEUE_SIZE);
		for (int i = 0; i < INPUT_QUEUE_SIZE; i++) {
			inputObjectPool.add(new InputObject(inputObjectPool));
		}
	}
	
	@Override
	public boolean onTouchEvent(MotionEvent event) {
		try {
			int hist = event.getHistorySize();
			for (int i = 0; i < hist; i++) {
				InputObject input = inputObjectPool.take();
				input.useEventHistory(event, i);
				mGameThread.feedInput(input);
			}
			InputObject input = inputObjectPool.take();
			input.useEvent(event);
			mGameThread.feedInput(input);
		} catch (InterruptedException e) {
		}
		try {
			Thread.sleep(16);
		} catch (InterruptedException e) {
		}
		return true;
	}
}